/* I2C-Bus Portexpander mit lowaktiven LEDs SDA -> P1.0, SCL -> P1.1 */

#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100

/* Funktionen fuer I2C-Busschnittstelle (Master-Mode)
#define SDA  0       // Bit P1.0
#define SCL  1       // Bit P1.1
extern void    i2c_init    ( void );
extern void    i2c_start   ( void );
extern void    i2c_stop    ( void );
extern uint8_t i2c_write   ( uint8_t value);     // Rückgabewert Ack/Nack
extern uint8_t i2c_read    ( uint8_t ack );      // Rückgabewert value	*/

#define schalter4 p0				// 4 Schalter P0.0 bis P0.3
#define sendetaster 2
#define ack_anzeige 4
uint8_t ack_bit;					// Ack-Bit Empfangen-> 0

int main(void)						// Hauptprogramm
{
	port_init(P0,INP);				// später 4 Schaltern einlesen
	i2c_init();						// I2C initialisieren
	bit_init(P2,sendetaster,INP);	// für spätere Ausgabe an I2C-Bus nach Tastendruck P2.2
	bit_init(P1,ack_anzeige,OUTP);	// ACK anzeigen an LED: ACK LED aus, NACK LED an
	bit_write(P1,ack_anzeige,1);	// zuerst NACK
  while(1U)							// Endlosschleife
  {
	  while(bit_read(P2,sendetaster)==1);				//warten auf Tastendruck P2.2
	  i2c_start();										// Startbedingung
	  ack_bit = i2c_write(0b01110010);					// PortExpander TypA Adr 001
	  if (ack_bit==0) ack_bit=i2c_write(port_read(P0));	// 8 Bit P0 kopieren an Portexpander
	  	  	  	  	  	  	  	  						// LEDs dort sind lowaktiv!!
	  i2c_stop();										// Stopbedingung
	  bit_write(P1,ack_anzeige,ack_bit);				// ACK / NACK anzeigen an LED
  }//while
}//main


