/* I2C-Bus Temperaturmessung SDA -> P1.0, SCL -> P1.1 */

#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100

/* Funktionen fuer I2C-Busschnittstelle (Master-Mode)
#define SDA  0       // Bit P1.0
#define SCL  1       // Bit P1.1
#define ACK  0
#define NACK 1
extern void    i2c_init    ( void );
extern void    i2c_start   ( void );
extern void    i2c_stop    ( void );
extern uint8_t i2c_write   ( uint8_t value);     // Rückgabewert Ack/Nack
extern uint8_t i2c_read    ( uint8_t ack );      // Rückgabewert value	*/

#define ack_anzeige 4
uint8_t ack_bit;					// Ack-Bit Empfangen-> 0
uint8_t tempL,temp, config;			// Temperaturspeicher, Register

int main(void)						// Hauptprogramm
{
	port_init(P0,OUTP);				//
	delay_ms(500);					// warten bis LCD-Controller gestartet
	lcd_init();						// LCD initialisieren
	i2c_init();						// I2C initialisieren
	bit_init(P1,ack_anzeige,OUTP);	// ACK anzeigen an LED: ACK LED aus, NACK LED an
	bit_write(P1,ack_anzeige,1);	// zuerst NACK
	i2c_start();					// Startbedingung
	i2c_write(0x9A);				// Adresse, Master schreibt R/W=0
	i2c_write(0xEE);				// kontinuierliche Wandlung
	i2c_stop();						// Stoppbedingung
	/*do							//### Abfrage dauert extrem lang????
	{								// warten bis ADC den ersten Wert liefert
		i2c_start();				// Startbedingung
		i2c_write(0x9A);			// Adresse, Master schreibt R/W=0
		i2c_write(0xAC);			// Zugriff auf Configuration-/Statusregister
		i2c_start();				// repeatet Start
		ack_bit=i2c_write(0x9B);	// Adresse, Master möchte 1 Byte lesen R/W=1
		config=i2c_read(NACK);		// Configurationsregister
		i2c_stop();					// Stoppbedingung
		port_write(P0,config);
		bit_write(P1,ack_anzeige,ack_bit); // Ack-Bit fühlt sich IC angesprochen?
	}
	while (((config & 0x80)==0)||(ack_bit==1)); // ADC fertig oder kein IC vorhanden */
	lcd_print ( "Temperatur" );     // Textausgabe LCD
  while(1U)							// Endlosschleife
  {
	  i2c_start();					// Startbedingung
	  i2c_write(0x9A);				// Adresse R/W=0
	  i2c_write(0xAA);				// Command_ Temperatur lesen , R/W=0
	  i2c_start();					// repeatet Start
	  ack_bit=i2c_write(0x9B);		// Adresse und R/W=1
	  temp=i2c_read(ACK);			// Temp in Grad lesen
	  tempL=i2c_read(NACK);			// Temp 0,5 Grad lesen, letztes Lesebyte
	  i2c_stop();					// Stoppbedingung
	  lcd_setcursor ( 2,1 );     	// Cursorposition LCD 2. Zeile
	  lcd_byte ( temp );			// Temperatur anzeigen
	  lcd_char ('.');				// Komma
	  if (tempL==0) lcd_char ('0'); else lcd_char ('5'); // Nachkommastelle
	  lcd_char('°');
	  lcd_char('C');				// Grad C
	  bit_write(P1,ack_anzeige,ack_bit); // Ack-Bit fühlt sich IC angesprochen?
  }//while
}//main


